package com.orange.widget.app

import android.app.Application
import com.alibaba.android.arouter.launcher.ARouter
import com.liulishuo.filedownloader.FileDownloader
import com.liulishuo.filedownloader.connection.FileDownloadConnection
import com.liulishuo.filedownloader.connection.FileDownloadUrlConnection
import com.orange.net.net.NetHelper
import com.orange.tool.app.AppUrl
import com.orange.tool.app.IApp
import com.orange.widget.util.NoEtagFileDownloadUrlConnection
import xyz.doikki.videoplayer.util.PlayerUtils.getApplication
import java.io.IOException


class App : IApp(){

    companion object{
        private lateinit var app:Application
        fun getApp():Application = app
    }


    override fun onCreate() {
        super.onCreate()

        initAll(this)
    }

    fun initAll(app: Application){
        App.app = app
        NetHelper.netHelper.init(AppUrl.netUrl)

        ARouter.openLog()
        ARouter.openDebug()
        ARouter.init(app)
       // FileDownloader.setupOnApplicationOnCreate(getApplication())
        FileDownloader.setupOnApplicationOnCreate(getApplication())
            .connectionCreator(object : FileDownloadUrlConnection.Creator(
                FileDownloadUrlConnection.Configuration()
                    .connectTimeout(15000) // set connection timeout.
                    .readTimeout(15000) // set read timeout.
            ) {
                @Throws(IOException::class)
                override fun create(originUrl: String): FileDownloadConnection {
                    return NoEtagFileDownloadUrlConnection(originUrl)
                }
            })
            .commit()
    }

    override fun init(app: Application, applicationFlag: Boolean) {
        if(!applicationFlag){
            initAll(app)
        }
    }

}